macroScript wwSMDCollisionPrep
category:"wallworm.com"
tooltip:"Prepare SMD Collisionmodel by applying unique smoothing groups to each mesh element and adding a texture."
buttontext:"SMD Collision Prep"
(


global WWCollisionMeshPrep

try(destroyDialog WWCollisionMeshPrep)catch(
	
	   format "****** % \n" (getCurrentException())
	)


rollout WWCollisionMeshPrep "SMD Collision Mesh Prep" width:311 height:634
(
	
	bitmap the_bmp "" pos:[0,0] width:311 height:619 fileName:"$scripts\Wallworm\wallworm_productions_smdtool.png" 
 
 
 
	pickbutton meshSelector "Select Mesh" pos:[12,65] width:290 height:47 toolTip:"Select the mesh that will be the collisionmodel"
	label meshName "No Mesh Selected" pos:[14,122] width:174 height:21 backgroundColor:(color 255 255 255)
	label TotalElements "Elements in Mesh:" pos:[14,144] width:174 height:20 backgroundColor:(color 255 255 255)
	
	
	
	label credits "SMD Collisionmodel Tool programmed by:" pos:[13,480] width:290 height:13
	HyperLink ShawnLink "Shawn Olson" pos:[13,498] width:63 height:15 color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255) address:"http://www.shawnolson.net"
	HyperLink AndrewLink "Andrew Penry" pos:[13,518] width:66 height:15 color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255) address:"http://www.andrewpenry.com"
	HyperLink WallWormLink "Help?" pos:[13,538] width:28 height:15 color:(color 0 0 255) hovercolor:(color 255 0 0) visitedcolor:(color 0 0 255) address:"http://www.wallworm.com/smdcollisionmodel.html"
	label appVersion "Version 1.1" pos:[129,558] width:63 height:13
	button addPlayerBoxBtn "Add Player Box" pos:[15,176] width:172 height:21
	GroupBox grp1 "Collision Mesh Tools" pos:[7,51] width:300 height:121

	
	
	on meshSelector picked obj do
	(
		meshName.caption =  "Mesh Name: "+ obj.name 
	convertto obj editable_poly
	obj.selectMode = 1
	--obj.subobjectLevel = 5
	
	
	(
	--This block from http://forums.cgsociety.org/showthread.php?f=98&t=665011&highlight=element
	--Thank You Martijn van Herk
	-- Array to store elements
	local Elements = #()
	
	-- Array containing all face indices
	local Faces = #{1..obj.numFaces} as array
	
	-- Loop until nothing left in 'Faces' array
	while Faces.count > 0 do
	(
		-- Get the element using the first face in the 'Faces' array
		local FaceElem = polyOp.getElementsUsingFace obj Faces[1]
		
		-- Subtract the element from the 'Faces' array
		Faces = ((Faces as bitArray) - FaceElem) as array
		
		-- Append the elements
		append Elements FaceElem
	)
	
	-- 'Elements' now contains an array of bitarrays
	--Elements
	)
		
		--print Elements as string
		TotalElements.caption = "Elements in Mesh: "  + Elements.count as string
	
	
	
	       local sg = 1
	    for item in Elements do (
	
			polyop.setFaceSmoothGroup obj item sg add:false
			
			
			sg = sg * 2
			
			
			)
	
	
			
			
			
			files = getFiles("$scripts\\Wallworm\\worm_stamp_1.png")
	wallwormjpg = openBitmap(files[1])
			wallwormjpg.filename = files[1]
			
			--wallwormjpg = bitmap 10 10 color:white
			
	obj.material = standard diffusemap:(BitmapTexture())
	obj.material.diffusemap.bitmap = wallwormjpg
	
	--if Elements.count <= 32 do ()
	
			
			
			
			
		
		
	)
	on addPlayerBoxBtn pressed do
		Box lengthsegs:1 widthsegs:1 heightsegs:1 length:24 width:24 name:"wwPlayerBox" height:72 mapcoords:on pos:[10.9065,15.4642,0] isSelected:on wirecolor:(color 27 177 27)
)

createDialog WWCollisionMeshPrep 311 615
)